## mfgtools 1.4.43

=== debian/changelog ===
mfgtools (1.4.43-1) unstable; urgency=medium

  * New upstream release
  * Mark autopkgtest as superficial

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Mon, 19 Oct 2020 12:21:53 +0000

mfgtools (1.3.191-1) unstable; urgency=medium

  * Initial release (Closes: #916693)

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Thu, 30 Jul 2020 18:58:01 +0000

## mfgtools 1.4.77

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_SKIP_RPATH ON)

option(BUILD_DOC "Build documentation" OFF)

add_subdirectory(libuuu)
add_subdirectory(uuu)

if (BUILD_DOC)
	# check if Doxygen is installed
	find_package(Doxygen)
	if (DOXYGEN_FOUND)
	    # set input and output files
	    set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
	    set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

	    # request to configure the file
	    configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT} @ONLY)
	    message("Doxygen build started")

	    # note the option ALL which allows to build the docs together with the application
	    add_custom_target( doc_doxygen ALL
		COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
		COMMENT "Generating documentation with Doxygen"
		VERBATIM )
	else (DOXYGEN_FOUND)
		message("Doxygen need to be installed to generate the doxygen documentation")
	endif (DOXYGEN_FOUND)
endif (BUILD_DOC)

=== libuuu/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_SKIP_RPATH ON)

find_package(BZip2 REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(LIBUSB REQUIRED libusb-1.0>=1.0.16)
pkg_check_modules(LIBZIP REQUIRED libzip)
find_package(Threads)

if (STATIC)
set(OPENSSL_USE_STATIC_LIBS TRUE)
endif()

find_package(OpenSSL)

if(OPENSSL_FOUND)
set(UUUSSL "-DUUUSSL")
set(UUUOPENSLL_INCLUDE_DIR ${OPENSSL_INCLUDE_DIR})
endif()

include_directories(${LIBUSB_INCLUDE_DIRS} ${UUUOPENSLL_INCLUDE_DIR} include)


set(CMAKE_CXX_FLAGS_DEBUG "-g -Wall -Wstrict-aliasing -Wextra ${UUUSSL}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 ${UUUSSL}")

set(SOURCES
	error.cpp
	buffer.cpp
	cmd.cpp
	config.cpp
	notify.cpp
	sdps.cpp
	trans.cpp
	usbhotplug.cpp
	version.cpp
	sdp.cpp
	gitversion.h
	fastboot.cpp
	zip.cpp
	fat.cpp
	tar.cpp
	rominfo.cpp
	http.cpp
	hidreport.cpp
	sparse.cpp
)

set(generated_files_dir "${CMAKE_BINARY_DIR}/libuuu/gen")
set(gitversion_h "${generated_files_dir}/gitversion.h")

add_custom_command(
	OUTPUT gitversion.h
	PRE_BUILD
	COMMAND mkdir -p ${generated_files_dir}
	COMMAND sh -c 'cd ${CMAKE_CURRENT_SOURCE_DIR} && rm -f ${gitversion_h} && ./gen_ver.sh "${gitversion_h}.tmp" && mv -f "${gitversion_h}.tmp" "${gitversion_h}"'

)
include_directories(${generated_files_dir})

#add_library( uuc SHARED ${SOURCES} ))
add_library( uuc_s STATIC ${SOURCES} )

=== uuu/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_SKIP_RPATH ON)

find_package(PkgConfig REQUIRED)
pkg_check_modules(LIBUSB REQUIRED libusb-1.0>=1.0.16)
pkg_check_modules(LIBZIP REQUIRED libzip)
pkg_check_modules(LIBZ REQUIRED zlib)
find_package(Threads)

if (STATIC)
set(OPENSSL_USE_STATIC_LIBS TRUE)
endif()

find_package(OpenSSL)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -O2")

if (STATIC)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++ -static-libgcc")
endif()

set(LSTS
	uuu.lst
	emmc_burn_loader.lst
	emmc_burn_all.lst
	fat_write.lst
	qspi_burn_loader.lst
	sd_burn_loader.lst
	spl_boot.lst
	sd_burn_all.lst
	nand_burn_loader.lst
)

link_directories(${CMAKE_CURRENT_SOURCE_DIR}/libuuu ${LIBUSB_LIBRARY_DIRS} ${LIBZIP_LIBRARY_DIRS} ${LIBZ_LIBRARY_DIRS})

set(CLIST_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/gen_txt_include.sh)
set(generated_files_dir "${CMAKE_BINARY_DIR}/uuu/gen")

function(preprocess_clst out_var)
	set(result)
	foreach(in_f ${ARGN})
		set(out_f "${generated_files_dir}/${in_f}")
		string(REPLACE ".lst" ".clst" out_f ${out_f})
		add_custom_command(OUTPUT ${out_f}
			PRE_BUILD
				COMMAND mkdir -p ${generated_files_dir}
			COMMAND ${CLIST_EXECUTABLE} ${in_f} ${out_f}
			DEPENDS ${in_f}
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			COMMENT "Creating preprocessed clst file ${out_f}"
			VERBATIM
		)
		list(APPEND result ${out_f})
	endforeach()
	set(${out_var} "${result}" PARENT_SCOPE)
endfunction()

preprocess_clst(CLSTS ${LSTS})

include_directories(${generated_files_dir})

set(SOURCES
	uuu.cpp
	buildincmd.cpp
	autocomplete.cpp
	${CLSTS}
)

add_executable(uuu ${SOURCES})
target_link_libraries(uuu uuc_s ${OPENSSL_LIBRARIES} ${LIBUSB_LIBRARIES} ${LIBZIP_LIBRARIES} ${LIBZ_LIBRARIES} dl bz2)

install(TARGETS uuu DESTINATION bin)
add_compile_definitions(TARGET_PATH="${CMAKE_INSTALL_PREFIX}/bin/uuu")

## mfgtools 1.4.69

=== debian/changelog ===
mfgtools (1.4.69-1) unstable; urgency=medium

  * d/patches: remove 001_cmakelist_so+bhlc+repro.patch, merged upstream
  * New upstream version 1.4.69

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Mon, 14 Dec 2020 12:36:46 +0000

=== debian/control ===
Source: mfgtools
Section: admin
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders:
 Henry-Nicolas Tourneur <debian@nilux.be>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 help2man,
 libbz2-dev,
 libusb-1.0-0-dev,
 libzip-dev,
 libssl-dev,
 pkg-config,
 zlib1g-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/NXPmicro/mfgtools
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/mfgtools.git
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/mfgtools

Package: uuu
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Freescale/NXP I.MX Chip image deploy tools
 Universal update utility for I.MX CPUs. It can be used to e.g. burn uboot or a
 rootfs into the emmc.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath,+fixdebugpath
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

execute_before_dh_auto_configure:
	echo "$(DEB_VERSION_UPSTREAM)" > .tarball-version

# generate the manpages from the scripts using help2man
execute_before_dh_installman:
	help2man --version-option='-h' --help-option='-h' --no-info --name="Freescale/NXP I.MX Chip image deploy tools" \
		debian/uuu/usr/bin/uuu | sed 's/\x1b\[[0-9;]*m//g' > debian/uuu.1

## mfgtools 1.4.72

=== debian/changelog ===
mfgtools (1.4.72-1) unstable; urgency=medium

  * New upstream version 1.4.72
  * Set Standard-Version to 4.5.1, no changes needed.

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Sun, 17 Jan 2021 15:24:50 +0000

## mfgtools 1.4.77

=== debian/changelog ===
mfgtools (1.4.77-1) unstable; urgency=medium

  * New upstream version 1.4.77

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Mon, 25 Jan 2021 17:38:40 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libssl-dev,
  pkg-config,
  zlib1g-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/NXPmicro/mfgtools
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/mfgtools.git

## mfgtools 1.4.165

=== debian/changelog ===
mfgtools (1.4.165-1) unstable; urgency=medium

  * New upstream version 1.4.165

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Sun, 03 Oct 2021 21:38:04 +0000

mfgtools (1.4.149-1) unstable; urgency=medium

  * New upstream version 1.4.149

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Wed, 25 Aug 2021 09:32:17 +0000

mfgtools (1.4.139-2) unstable; urgency=medium

  * d/rules: fix FTBFS on armel/mipsel/m68k/powerpc/sh4
    must link with libatomic (Closes: #992576) - thanks to Adrian Bunk.

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Fri, 20 Aug 2021 12:18:30 +0000

mfgtools (1.4.139-1) unstable; urgency=medium

  * New upstream version 1.4.139

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Sun, 15 Aug 2021 08:08:49 +0000

## mfgtools 1.4.174

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.12)
+cmake_minimum_required(VERSION 3.4)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== debian/changelog ===
mfgtools (1.4.174-1) unstable; urgency=medium

  * New upstream version 1.4.174
  * d/control: bump Standards-Version to 4.6.0 (no changes needed)

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Sat, 01 Jan 2022 23:31:06 +0000

## mfgtools 1.4.191

=== debian/changelog ===
mfgtools (1.4.191-1) unstable; urgency=medium

  * New upstream version 1.4.191

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Fri, 28 Jan 2022 16:02:32 +0000

## mfgtools 1.4.193

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.4)
+
+project(uuu)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== libuuu/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.12)
+cmake_minimum_required(VERSION 3.4)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -7,7 +7,6 @@
 find_package(BZip2 REQUIRED)
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(LIBUSB REQUIRED libusb-1.0>=1.0.16)
-pkg_check_modules(LIBZIP REQUIRED libzip)
 find_package(Threads)
 
 if (STATIC)

=== uuu/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.12)
+cmake_minimum_required(VERSION 3.4)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -6,7 +6,6 @@
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(LIBUSB REQUIRED libusb-1.0>=1.0.16)
-pkg_check_modules(LIBZIP REQUIRED libzip)
 pkg_check_modules(LIBZ REQUIRED zlib)
 find_package(Threads)
 
@@ -34,7 +33,7 @@
 	nand_burn_loader.lst
 )
 
-link_directories(${CMAKE_CURRENT_SOURCE_DIR}/libuuu ${LIBUSB_LIBRARY_DIRS} ${LIBZIP_LIBRARY_DIRS} ${LIBZ_LIBRARY_DIRS})
+link_directories(${CMAKE_CURRENT_SOURCE_DIR}/libuuu ${LIBUSB_LIBRARY_DIRS} ${LIBZ_LIBRARY_DIRS})
 
 set(CLIST_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/gen_txt_include.sh)
 set(generated_files_dir "${CMAKE_BINARY_DIR}/uuu/gen")
@@ -70,7 +69,9 @@
 )
 
 add_executable(uuu ${SOURCES})
-target_link_libraries(uuu uuc_s ${OPENSSL_LIBRARIES} ${LIBUSB_LIBRARIES} ${LIBZIP_LIBRARIES} ${LIBZ_LIBRARIES} dl bz2)
+target_link_libraries(uuu uuc_s ${OPENSSL_LIBRARIES} ${LIBUSB_LIBRARIES} ${LIBZ_LIBRARIES} dl bz2)
 
 install(TARGETS uuu DESTINATION bin)
-add_compile_definitions(TARGET_PATH="${CMAKE_INSTALL_PREFIX}/bin/uuu")
+target_compile_definitions(uuu
+    PRIVATE "TARGET_PATH=\"${CMAKE_INSTALL_PREFIX}/bin/uuu\""
+)

=== debian/changelog ===
mfgtools (1.4.193-1) unstable; urgency=medium

  * New upstream version 1.4.193

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Tue, 22 Feb 2022 16:27:47 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libssl-dev,
  pkg-config,
  zlib1g-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/NXPmicro/mfgtools
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/mfgtools.git

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,10 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath,+fixdebugpath
 include /usr/share/dpkg/pkg-info.mk
+
+ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc sh4))
+export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
+endif
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/uuu_(\d\S+)\.tar\.gz/uuu_$1\.tar\.gz/ \
  https://github.com/NXPmicro/mfgtools/tags .*/uuu_(\d\S+)\.tar\.gz

## mfgtools 1.5.21

=== debian/changelog ===
mfgtools (1.5.21-2) unstable; urgency=medium

  * Generate udev 70-uuu.rules at build and ship it

 -- Andreas Henriksson <andreas@fatal.se>  Wed, 28 Jun 2023 14:45:57 +0200

mfgtools (1.5.21-1) experimental; urgency=medium

  * debian/gbp.conf: Set upstream-vcs-tag
  * New upstream release. (Closes: #1032882)
  * Update build-deps according to upstream changes
    - Drop libzip-dev
    - Add libzstd-dev
  * Add myself to uploaders

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 13 Mar 2023 14:39:10 +0100

=== debian/rules ===
--- 
+++ 
@@ -17,3 +17,8 @@
 execute_before_dh_installman:
 	help2man --version-option='-h' --help-option='-h' --no-info --name="Freescale/NXP I.MX Chip image deploy tools" \
 		debian/uuu/usr/bin/uuu | sed 's/\x1b\[[0-9;]*m//g' > debian/uuu.1
+
+# generate udev rules
+execute_after_dh_auto_install:
+	test -e debian/uuu && mkdir -p debian/uuu/lib/udev/rules.d
+	debian/uuu/usr/bin/uuu -udev > debian/uuu/lib/udev/rules.d/70-uuu.rules 2>/dev/null

## mfgtools 1.5.109

=== libuuu/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 find_package(BZip2 REQUIRED)
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(LIBUSB REQUIRED libusb-1.0>=1.0.16)
+pkg_check_modules(LIBZSTD REQUIRED libzstd)
 find_package(Threads)
 
 if (STATIC)
@@ -20,7 +21,7 @@
 set(UUUOPENSLL_INCLUDE_DIR ${OPENSSL_INCLUDE_DIR})
 endif()
 
-include_directories(${LIBUSB_INCLUDE_DIRS} ${UUUOPENSLL_INCLUDE_DIR} include)
+include_directories(${LIBUSB_INCLUDE_DIRS} ${LIBZSTD_INCLUDE_DIRS} ${UUUOPENSLL_INCLUDE_DIR} include)
 
 
 set(CMAKE_CXX_FLAGS_DEBUG "-g -Wall -Wstrict-aliasing -Wextra ${UUUSSL}")

=== uuu/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(LIBUSB REQUIRED libusb-1.0>=1.0.16)
 pkg_check_modules(LIBZ REQUIRED zlib)
+pkg_check_modules(LIBZSTD REQUIRED libzstd)
 find_package(Threads)
 
 if (STATIC)
@@ -31,9 +32,10 @@
 	spl_boot.lst
 	sd_burn_all.lst
 	nand_burn_loader.lst
+	nvme_burn_all.lst
 )
 
-link_directories(${CMAKE_CURRENT_SOURCE_DIR}/libuuu ${LIBUSB_LIBRARY_DIRS} ${LIBZ_LIBRARY_DIRS})
+link_directories(${CMAKE_CURRENT_SOURCE_DIR}/libuuu ${LIBUSB_LIBRARY_DIRS} ${LIBZSTD_LIBRARY_DIRS} ${LIBZ_LIBRARY_DIRS})
 
 set(CLIST_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/gen_txt_include.sh)
 set(generated_files_dir "${CMAKE_BINARY_DIR}/uuu/gen")
@@ -69,7 +71,7 @@
 )
 
 add_executable(uuu ${SOURCES})
-target_link_libraries(uuu uuc_s ${OPENSSL_LIBRARIES} ${LIBUSB_LIBRARIES} ${LIBZ_LIBRARIES} dl bz2)
+target_link_libraries(uuu uuc_s ${OPENSSL_LIBRARIES} ${LIBUSB_LIBRARIES} ${LIBZ_LIBRARIES} ${LIBZSTD_LIBRARIES}  dl bz2)
 
 install(TARGETS uuu DESTINATION bin)
 target_compile_definitions(uuu

=== debian/changelog ===
mfgtools (1.5.109-1) unstable; urgency=medium

  * New upstream release.
  * debian/rules: remove generated manpage on clean

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 03 Jul 2023 17:04:12 +0200

## mfgtools 1.5.125

=== debian/changelog ===
mfgtools (1.5.125-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Thu, 10 Aug 2023 13:19:00 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,14 @@
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders:
  Henry-Nicolas Tourneur <debian@nilux.be>,
+ Andreas Henriksson <andreas@fatal.se>,
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
  help2man,
  libbz2-dev,
+ libzstd-dev,
  libusb-1.0-0-dev,
- libzip-dev,
  libssl-dev,
  pkg-config,
  zlib1g-dev,

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,9 @@
 	help2man --version-option='-h' --help-option='-h' --no-info --name="Freescale/NXP I.MX Chip image deploy tools" \
 		debian/uuu/usr/bin/uuu | sed 's/\x1b\[[0-9;]*m//g' > debian/uuu.1
 
+execute_after_dh_clean:
+	rm -f debian/uuu.1
+
 # generate udev rules
 execute_after_dh_auto_install:
 	test -e debian/uuu && mkdir -p debian/uuu/lib/udev/rules.d

## mfgtools 1.5.139

=== debian/changelog ===
mfgtools (1.5.139-1) unstable; urgency=medium

  * Cleanup generated .tarball-version (Closes: #1049209)
  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 05 Nov 2023 21:46:29 +0100

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 		debian/uuu/usr/bin/uuu | sed 's/\x1b\[[0-9;]*m//g' > debian/uuu.1
 
 execute_after_dh_clean:
-	rm -f debian/uuu.1
+	rm -f debian/uuu.1 .tarball-version
 
 # generate udev rules
 execute_after_dh_auto_install:

## mfgtools 1.5.141

=== libuuu/CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,12 @@
 include_directories(${LIBUSB_INCLUDE_DIRS} ${LIBZSTD_INCLUDE_DIRS} ${UUUOPENSLL_INCLUDE_DIR} include)
 
 
-set(CMAKE_CXX_FLAGS_DEBUG "-g -Wall -Wstrict-aliasing -Wextra ${UUUSSL}")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 ${UUUSSL}")
+if (FORCE_OLD)
+set(FORCE_OLDLIBUSB "-DFORCE_OLDLIBUSB")
+endif()
+
+set(CMAKE_CXX_FLAGS_DEBUG "-g -Wall -Wstrict-aliasing -Wextra ${UUUSSL} ${FORCE_OLDLIBUSB}")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 ${UUUSSL} ${FORCE_OLDLIBUSB}")
 
 set(SOURCES
 	error.cpp

=== uuu/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,7 @@
 	emmc_burn_all.lst
 	fat_write.lst
 	qspi_burn_loader.lst
+	fspinand_burn_loader.lst
 	sd_burn_loader.lst
 	spl_boot.lst
 	sd_burn_all.lst

=== debian/changelog ===
mfgtools (1.5.141-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:56:47 +1100

mfgtools (1.5.141-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 19:59:56 +0000

mfgtools (1.5.141-1) unstable; urgency=medium

  [ Andreas Henriksson ]
  * New upstream release.

  [ Chris Hofstaedtler ]
  * Use udev.pc to place udev rules file (Closes: #1057829)

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 10 Dec 2023 09:08:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mfgtools
 Section: admin
 Priority: optional
-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders:
  Henry-Nicolas Tourneur <debian@nilux.be>,
  Andreas Henriksson <andreas@fatal.se>,
@@ -14,6 +15,7 @@
  libusb-1.0-0-dev,
  libssl-dev,
  pkg-config,
+ systemd-dev,
  zlib1g-dev,
 Standards-Version: 4.6.0
 Rules-Requires-Root: no

## mfgtools 1.5.182

=== debian/changelog ===
mfgtools (1.5.182-1) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * uuu: Add Appstream metainfo XML with hardware mapping (Closes: #1070263)

  [ Andreas Henriksson ]
  * New upstream release.
  * Build-dep on tinyxml2
  * Build-dep pkg-config -> pkgconf

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 28 Sep 2024 12:01:05 +0200

## mfgtools 1.5.191

=== debian/changelog ===
mfgtools (1.5.191-1) unstable; urgency=medium

  * Fix appstream metadata issues
  * debian/gbp.conf: Rename branch to debian/latest
  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 18 Nov 2024 19:40:50 +0100

## mfgtools 1.5.201

=== libuuu/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
 pkg_check_modules(LIBUSB REQUIRED libusb-1.0>=1.0.16)
 pkg_check_modules(LIBZSTD REQUIRED libzstd)
 find_package(Threads)
+pkg_check_modules(TINYXML2 REQUIRED tinyxml2)
 
 if (STATIC)
 set(OPENSSL_USE_STATIC_LIBS TRUE)
@@ -21,7 +22,7 @@
 set(UUUOPENSLL_INCLUDE_DIR ${OPENSSL_INCLUDE_DIR})
 endif()
 
-include_directories(${LIBUSB_INCLUDE_DIRS} ${LIBZSTD_INCLUDE_DIRS} ${UUUOPENSLL_INCLUDE_DIR} include)
+include_directories(${LIBUSB_INCLUDE_DIRS} ${LIBZSTD_INCLUDE_DIRS} ${UUUOPENSLL_INCLUDE_DIR} ${TINYXML2_INCLUDE_DIRS} include)
 
 
 if (FORCE_OLD)
@@ -29,7 +30,7 @@
 endif()
 
 set(CMAKE_CXX_FLAGS_DEBUG "-g -Wall -Wstrict-aliasing -Wextra ${UUUSSL} ${FORCE_OLDLIBUSB}")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 ${UUUSSL} ${FORCE_OLDLIBUSB}")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${UUUSSL} ${FORCE_OLDLIBUSB}")
 
 set(SOURCES
 	error.cpp
@@ -51,6 +52,7 @@
 	http.cpp
 	hidreport.cpp
 	sparse.cpp
+	bmap.cpp
 )
 
 set(generated_files_dir "${CMAKE_BINARY_DIR}/libuuu/gen")

=== uuu/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
 pkg_check_modules(LIBZ REQUIRED zlib)
 pkg_check_modules(LIBZSTD REQUIRED libzstd)
 find_package(Threads)
+pkg_check_modules(TINYXML2 REQUIRED tinyxml2)
 
 if (STATIC)
 set(OPENSSL_USE_STATIC_LIBS TRUE)
@@ -20,6 +21,8 @@
 
 if (STATIC)
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++ -static-libgcc")
+set(TINYXML2_LIBRARY_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/../tinyxml2")
+set(TINYXML2_LIBRARIES "tinyxml2.a")
 endif()
 
 set(LSTS
@@ -36,7 +39,7 @@
 	nvme_burn_all.lst
 )
 
-link_directories(${CMAKE_CURRENT_SOURCE_DIR}/libuuu ${LIBUSB_LIBRARY_DIRS} ${LIBZSTD_LIBRARY_DIRS} ${LIBZ_LIBRARY_DIRS})
+link_directories(${CMAKE_CURRENT_SOURCE_DIR}/libuuu ${LIBUSB_LIBRARY_DIRS} ${LIBZSTD_LIBRARY_DIRS} ${LIBZ_LIBRARY_DIRS} ${TINYXML2_LIBRARY_DIRS})
 
 set(CLIST_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/gen_txt_include.sh)
 set(generated_files_dir "${CMAKE_BINARY_DIR}/uuu/gen")
@@ -72,7 +75,7 @@
 )
 
 add_executable(uuu ${SOURCES})
-target_link_libraries(uuu uuc_s ${OPENSSL_LIBRARIES} ${LIBUSB_LIBRARIES} ${LIBZ_LIBRARIES} ${LIBZSTD_LIBRARIES}  dl bz2)
+target_link_libraries(uuu uuc_s ${OPENSSL_LIBRARIES} ${LIBUSB_LIBRARIES} ${LIBZ_LIBRARIES} ${LIBZSTD_LIBRARIES} ${TINYXML2_LIBRARIES} dl bz2)
 
 install(TARGETS uuu DESTINATION bin)
 target_compile_definitions(uuu

=== wrapper/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(libuuu)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_SKIP_RPATH ON)

# Prefix all shared libraries with 'lib'.
set(CMAKE_SHARED_LIBRARY_PREFIX "")
# Prefix all static libraries with 'lib'.
set(CMAKE_STATIC_LIBRARY_PREFIX "")

# Set the directory where generated files will be placed
set(generated_files_dir "${CMAKE_BINARY_DIR}/libuuu/gen")

# Add the generated files directory to the include path
include_directories(${generated_files_dir})

# Set the path for gitversion.h in the generated files directory
set(gitversion_h "${generated_files_dir}/gitversion.h")

# Run git describe
execute_process(COMMAND git describe --long --always OUTPUT_VARIABLE version OUTPUT_STRIP_TRAILING_WHITESPACE)

# Add a custom command to generate definitions.h
if (WIN32)
add_custom_command(
    OUTPUT ${gitversion_h}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${generated_files_dir}
    COMMAND ${CMAKE_COMMAND} -E echo "#define GIT_VERSION \"${version}\"" >> ${gitversion_h};
    COMMAND ${CMAKE_COMMAND} -E echo "#define PLATFORM_WINDOWS 1" >> ${gitversion_h}
    COMMAND ${CMAKE_COMMAND} -E echo "#define ENABLE_LOGGING 1" >> ${gitversion_h}
    COMMAND ${CMAKE_COMMAND} -E echo "#define DEFAULT_VISIBILITY /**/" >> ${gitversion_h}
    COMMENT "Generating gitversion.h"
    VERBATIM
)
else ()
add_custom_command(
    OUTPUT ${gitversion_h}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${generated_files_dir}
    COMMAND ${CMAKE_COMMAND} -E echo "#define GIT_VERSION \"${version}\"" >> ${gitversion_h};
    COMMENT "Generating gitversion.h"
    VERBATIM
)
endif (WIN32)

add_library(
    libuuu 
    SHARED
    ../libuuu/error.cpp
    ../libuuu/buffer.cpp
    ../libuuu/cmd.cpp
    ../libuuu/config.cpp
    ../libuuu/notify.cpp
    ../libuuu/sdps.cpp
    ../libuuu/trans.cpp
    ../libuuu/usbhotplug.cpp
    ../libuuu/version.cpp
    ../libuuu/sdp.cpp
    ../libuuu/fastboot.cpp
    ../libuuu/zip.cpp
    ../libuuu/fat.cpp
    ../libuuu/tar.cpp
    ../libuuu/rominfo.cpp
    ../libuuu/http.cpp
    ../libuuu/hidreport.cpp
    ../libuuu/sparse.cpp
    ../libuuu/bmap.cpp
    ${gitversion_h}
)

find_package(PkgConfig REQUIRED)
pkg_check_modules(libusb REQUIRED IMPORTED_TARGET libusb-1.0)
pkg_check_modules(tinyxml2 REQUIRED IMPORTED_TARGET tinyxml2)
pkg_check_modules(bzip2 REQUIRED IMPORTED_TARGET bzip2)
pkg_check_modules(zstd REQUIRED IMPORTED_TARGET libzstd)
pkg_check_modules(openssl REQUIRED IMPORTED_TARGET openssl)
pkg_check_modules(zlib REQUIRED IMPORTED_TARGET zlib)


if (DARWIN)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
endif(DARWIN)    

if (WIN32)
add_definitions(-D_WIN32 -DWIN32 -DDLL_EXPORT_LIBUUU)
set(CMAKE_CXX_FLAGS_RELEASE "/MT")
set(CMAKE_CXX_FLAGS_DEBUG "/MTd")
endif(WIN32)

add_definitions(-DUUUSSL)

if (UNIX)
set(CMAKE_CXX_FLAGS "-g -Wall -Wstrict-aliasing -Wall -Wextra")
endif(UNIX)



target_link_libraries(libuuu PkgConfig::libusb PkgConfig::tinyxml2 PkgConfig::bzip2 PkgConfig::zstd PkgConfig::zlib PkgConfig::openssl)

=== wrapper/requirements.txt ===
setuptools-scm>=8

=== debian/changelog ===
mfgtools (1.5.201-1build1) questing; urgency=medium

  * No-change rebuild for libtinyxml2-11.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 03 May 2025 16:23:14 +0000

mfgtools (1.5.201-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 12 Jan 2025 18:53:28 +0100

=== debian/tests/control ===
Test-Command: uuu -h
Restrictions: allow-stderr superficial
Depends: @

## mfgtools 1.5.233

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.4)
+cmake_minimum_required(VERSION 3.5)
 
 project(uuu)

=== libuuu/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.4)
+cmake_minimum_required(VERSION 3.5)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== uuu/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.4)
+cmake_minimum_required(VERSION 3.5)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== wrapper/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 project(libuuu)
 
 set(CMAKE_CXX_STANDARD 14)

=== debian/changelog ===
mfgtools (1.5.233-1) unstable; urgency=medium

  * Drop patches from upstream
  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Thu, 16 Oct 2025 13:52:19 +0200

mfgtools (1.5.201-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with GCC 15. (Closes: #1097388)
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113283)

 -- Adrian Bunk <bunk@debian.org>  Thu, 09 Oct 2025 17:23:25 +0300

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: mfgtools
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
+Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders:
  Henry-Nicolas Tourneur <debian@nilux.be>,
  Andreas Henriksson <andreas@fatal.se>,
@@ -11,10 +10,11 @@
  debhelper-compat (= 13),
  help2man,
  libbz2-dev,
+ libtinyxml2-dev,
  libzstd-dev,
  libusb-1.0-0-dev,
  libssl-dev,
- pkg-config,
+ pkgconf,
  systemd-dev,
  zlib1g-dev,
 Standards-Version: 4.6.0

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc sh4))
 export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
 endif
+
+deb_udevdir = $(shell pkg-config --variable=udevdir udev)
 
 %:
 	dh $@
@@ -23,5 +25,5 @@
 
 # generate udev rules
 execute_after_dh_auto_install:
-	test -e debian/uuu && mkdir -p debian/uuu/lib/udev/rules.d
-	debian/uuu/usr/bin/uuu -udev > debian/uuu/lib/udev/rules.d/70-uuu.rules 2>/dev/null
+	test -e debian/uuu && mkdir -p debian/uuu/$(deb_udevdir)/rules.d
+	debian/uuu/usr/bin/uuu -udev > debian/uuu/$(deb_udevdir)/rules.d/70-uuu.rules 2>/dev/null

## mfgtools 1.5.239

=== wrapper/CMakeLists.txt ===
--- 
+++ 
@@ -18,10 +18,26 @@
 
 # Set the path for gitversion.h in the generated files directory
 set(gitversion_h "${generated_files_dir}/gitversion.h")
+# Run git describe without --always flag
+execute_process(
+    COMMAND git describe --tags --long 
+    OUTPUT_VARIABLE version 
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+    RESULT_VARIABLE git_result
+    ERROR_VARIABLE git_error
+)
 
-# Run git describe
-execute_process(COMMAND git describe --long --always OUTPUT_VARIABLE version OUTPUT_STRIP_TRAILING_WHITESPACE)
+# Check if git describe failed
+if(NOT git_result EQUAL 0)
+    message(FATAL_ERROR "Failed to get version from git: ${git_error}\n"
+                       "Make sure you have tags in your repository.\n"
+                       "Create a tag with: git tag uuu_1.0.0")
+endif()
 
+# Validate version format
+if(NOT version MATCHES "^uuu_[0-9]+\\.[0-9]+\\.[0-9]+(\\-[0-9]+\\-g[0-9a-f]+)?$")
+    message(FATAL_ERROR "Git version '${version}' doesn't match expected format 'uuu_X.Y.Z' or 'uuu_X.Y.Z-N-gHASH'")
+endif()
 # Add a custom command to generate definitions.h
 if (WIN32)
 add_custom_command(

=== debian/changelog ===
mfgtools (1.5.239-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 24 Nov 2025 10:19:46 +0100

## mfgtools 1.5.243

=== debian/changelog ===
mfgtools (1.5.243-1+rpi1) forky-staging; urgency=medium

  [changes brought forward from 1.4.193-1+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Tue, 21 Jun 2022 09:37:45 +0000]
  * Link with libatomic on armhf too.

 -- Raspbian forward porter <root@raspbian.org>  Tue, 03 Feb 2026 08:07:20 +0000

mfgtools (1.5.243-1) unstable; urgency=medium

  * New upstream release.
  * Update appstream metainfo

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 25 Jan 2026 15:05:25 +0100

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath,+fixdebugpath
 include /usr/share/dpkg/pkg-info.mk
 
-ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc sh4))
+ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf m68k mipsel powerpc sh4))
 export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
 endif
